#include "SD.h"
#include <stdio.h>
#include "config.h"
#include "spi.h"
#include "port.h"
// Ӧʱʱ
#define SD_CMD_TIMEOUT 1000
sbit SD_CS = P2^4;

u8 sdRspBuffer[32];
u8 isSDSCCard = 0;
u32 sdCardByteSize = 0;
// SD
u8 SD_SendCommand(u8 cmd, u32 arg)
{
	u8 i, response;
	

	// ͷ
	SPI_WriteByte(0x40 | cmd);
	// 
	SPI_WriteByte((u8)(arg >> 24));
	SPI_WriteByte((u8)(arg >> 16));
	SPI_WriteByte((u8)(arg >> 8));
	SPI_WriteByte((u8)arg);
	// CRC0xFF
	if (cmd == 0)
	{
		SPI_WriteByte(0x95); // CMD0CRC
	}
	else if (cmd == 8)
	{
		SPI_WriteByte(0x87); // CMD8CRC
	}
	else
	{
		SPI_WriteByte(0xFF);
	}
	for (i = 0; i < sizeof(sdRspBuffer); i++)
	{
		sdRspBuffer[i] = SPI_ReadByte();
	}
	i = 0;
	// ȴӦ

	do
	{
		response = sdRspBuffer[i];
		i++;
	} while ((response & 0x80) == 0x80 && i < sizeof(sdRspBuffer));

	if (cmd == 8 || cmd == 9 )//|| cmd == 41
	{
		printf("SD_SendCommand:%u\n",cmd);
		for (i = 0; i < 32; i++)
		{
			printf("%02X ",sdRspBuffer[i]);
		}
		printf("\n");
	}
	return response;
}

//#define    SPI_P24_P25_P26_P27        1
//#define  SPI_SW(Pin)                 P_SW1 = (P_SW1 & 0xF3) | (Pin << 2)
// ʼSD
u8 SD_Init(void)
{
	u8 i, response;
	u32 retry;
	u8 printDebugInfo;
	printDebugInfo = 0;
	P2M0 = 0;
	P2M1 = 0;
	
	SPI_Init();
	SPI_SwitchP2n();
    CLR_REG_BIT(HSSPI_CFG2, HSSPICFG2_IOSW_MSK);
	//SPI_SW(SPI_P24_P25_P26_P27); // SPI_P14_P15_P16_P17,SPI_P24_P25_P26_P27,SPI_P40_P41_P42_P43,SPI_P35_P34_P33_P32
	
	// 74ʱڵĿź
	if(printDebugInfo) printf("ʼ74ʱڵĿź...\n");
	SD_CS = 1;
	for (i = 0; i < 10; i++)
	{
		SPI_WriteByte(0xFF);
	}
	SD_CS = 0;
	if(printDebugInfo) printf("źŷɡ\n");

	// CMD0״̬
	if(printDebugInfo) printf("CMD0SD״̬...\n");
	retry = 0;
	do
	{
		response = SD_SendCommand(0, 0);
		retry++;
		if (retry > SD_CMD_TIMEOUT)
		{
			if(printDebugInfo) printf("CMD0ʱʼʧܡ\n");
			return 0xFF; // ʱ
		}
	} while (response != 0x01);
	if(printDebugInfo) printf("SDѳɹ״̬CMD0Ӧ0x%02X\n", response);

	// CMD8Ƿ֧2.0Э
	if(printDebugInfo) printf("CMD8SDǷ֧2.0Э...\n");
	response = SD_SendCommand(8, 0x1AA);
	if (response == 0x01)
	{
		if(printDebugInfo) printf("SD֧2.0Э飬CMD8Ӧ0x%02X\n", response);
		//  ȡ4ֽڵӦ
		if(printDebugInfo) printf("ȡCMD84ֽӦ...\n");
		for (i = 0; i < 4; i++)
		{
			SPI_ReadByte();
		}
		if(printDebugInfo) printf("CMD84ֽӦȡɡ\n");

		// ACMD41ǷΪSDHC/SDXC
		if(printDebugInfo) printf("ACMD41ȷCMD55ǷΪSDHC/SDXC...\n");
		retry = 0;
		do
		{
			SD_SendCommand(55, 0);
			response = SD_SendCommand(41, 0x40000000);
			retry++;
			if (retry > SD_CMD_TIMEOUT)
			{
				if(printDebugInfo) printf("ACMD41ʱʼʧܡ\n");
				return 0xFF; // ʱ
			}
		} while (response != 0x00);
		if(printDebugInfo) printf("SDѼACMD41Ӧ0x%02X\n", response);

		// CMD58ȡOCRĴ
		if(printDebugInfo) printf("CMD58ȡOCRĴ...\n");
		response = SD_SendCommand(58, 0);
		if (response == 0x00)
		{
			if(printDebugInfo) printf("ɹCMD58ʼȡOCRĴ4ֽ...\n");
			//  ȡ4ֽڵOCRĴ
			for (i = 0; i < 4; i++)
			{
				SPI_ReadByte();
			}
			if(printDebugInfo) printf("OCRĴ4ֽڶȡɡ\n");
		}
		else
		{
			if(printDebugInfo) printf("CMD58ʧܣӦ0x%02X\n", response);
		}
	}
	else
	{
		if(printDebugInfo) printf("SD֧2.0Э飬ǾɰSDSCCMD8Ӧ0x%02X\n", response);
		//  ɰSDSDSC
		if(printDebugInfo) printf("ھɰSDSCACMD41ȷCMD55...\n");
		retry = 0;
		do
		{
			SD_SendCommand(55, 0);
			response = SD_SendCommand(41, 0);
			retry++;
			if (retry > SD_CMD_TIMEOUT)
			{
				if(printDebugInfo) printf("ACMD41ʱʼʧܡ\n");
				return 0xFF; // ʱ
			}
		} while (response != 0x00);
		if(printDebugInfo) printf("ɰSDSCѼACMD41Ӧ0x%02X\n", response);
	}
	sdCardByteSize = SD_ReadCapacity();
	if(!sdCardByteSize){
		return 0xFF;
	}
	if(printDebugInfo) printf("SDʼɹ\n");
	return 0; // ʼɹ
}
u8 sendCmd41(void)
{
	u8 i, response;
	u32 retry;
	u8 printDebugInfo;
	if(isSDSCCard){
		return 0;
	}
	printDebugInfo = 0;
	// ACMD41ǷΪSDHC/SDXC
	if(printDebugInfo) printf("ACMD41ȷCMD55ǷΪSDHC/SDXC...\n");
	retry = 0;
	do
	{
		SD_SendCommand(55, 0);
		response = SD_SendCommand(41, 0x40000000);
		retry++;
		if (retry > SD_CMD_TIMEOUT)
		{
			if(printDebugInfo) printf("ACMD41ʱʼʧܡ\n");
			return 0xFF; // ʱ
		}
	} while (response != 0x00);
	if(printDebugInfo) printf("SDѼACMD41Ӧ0x%02X\n", response);

	return 0; // ʼɹ
}
// д뵥
u8 SD_WriteSingleBlock(u32 blockAddr, u8 *buffer)
{
	u8 response;
	u32 i;
	sendCmd41();
	// CMD24д뵥
	response = SD_SendCommand(24, blockAddr);
	if (response != 0x00)
	{
		return response;
	}

	// ʼ
	SPI_WriteByte(0xFE);

	// д512ֽڵ
	for (i = 0; i < 512; i++)
	{
		SPI_WriteByte(buffer[i]);
	}

	// 2ֽڵCRC0xFF
	SPI_WriteByte(0xFF);
	SPI_WriteByte(0xFF);

	// ȡӦ
	response = SPI_ReadByte();
	if ((response & 0x1F) != 0x05)
	{
		return response;
	}

	// ȴд
	do
	{
		response = SPI_ReadByte();
	} while (response == 0x00);

	return 0; // дɹ
}

// ȡ
u8 SD_ReadSingleBlock(u32 blockAddr, u8 *buffer)
{
	u8 response;
	u32 i;
	u32 retry = 0;

	// CMD17ȡ
	response = SD_SendCommand(17, blockAddr);
	if (response != 0x00)
	{
		return response;
	}

	// ȴʼ
	do
	{
		response = SPI_ReadByte();
		retry++;
		if (retry > SD_CMD_TIMEOUT)
		{
			return 0xFF; // ʱ
		}
	} while (response != 0xFE);

	// ȡ512ֽڵ
	for (i = 0; i < 512; i++)
	{
		buffer[i] = SPI_ReadByte();
	}

	// ȡ2ֽڵCRCԣ
	SPI_ReadByte();
	SPI_ReadByte();
	sendCmd41();

	return 0; // ȡɹ
}

// ȡSD
u32 SD_ReadCapacity()
{
	u8 response, i;
	u8* csd;
	u32 capacity;
	u32 c_size;
	u32 c_size_mult;
	u32 read_bl_len;

	// CMD9ȡCSDĴ
	response = SD_SendCommand(9, 0);
	if (response != 0x00)
	{
		return 0;
	}
	for (i = 0; i < sizeof(sdRspBuffer); i++)
	{
		if(sdRspBuffer[i] == 0xFE){
			i+=1;
			break;
		}
	}
	if((i+16) > sizeof(sdRspBuffer)){
		return 0;
	}
	csd = &sdRspBuffer[i];

	// жSD
	if ((csd[0] & 0xC0) == 0x40)
	{
		// SDHC/SDXC
		isSDSCCard = 0;
		capacity = 512 * 1024 * 1024; // λֽ
		// c_size = ((u32)(csd[6] & 0x3F) << 10) | (u32)(csd[7] << 2) | ((csd[8] & 0xC0) >> 6);
		// capacity = (u32)(c_size + 1ul) * 512ul * 1024ul; // λֽ
		//printf("SDHC/SDXC%lu ֽ,c_size:%lu\n", capacity,c_size);
		
	}
	else
	{
		// SDSC
		isSDSCCard = 1;
		capacity = 512 * 1024 * 1024; // λֽ
		// c_size_mult = ((u32)(csd[9] & 0x03) << 1) | ((u32)(csd[10] & 0x80) >> 7);
		// read_bl_len = csd[5] & 0x0F;
		// c_size = ((u32)(csd[6] & 0x03) << 10) | (csd[7] << 2) | ((csd[8] & 0xC0) >> 6);
		// capacity = (u32)(c_size + 1ul) * (1ul << (c_size_mult + 2)) * (1ul << read_bl_len) *512; // λֽ
		//printf("SDSC%lu ֽ,c_size:%lu,read_bl_len:%lu,c_size_mult:%lu\n", capacity,c_size,read_bl_len,c_size_mult);
	}
	
	return capacity;
}