#include "def.h"
#include "diskio_SD.h"
#include "SD.h"

void printBuffer(BYTE *buff);
u8 diskio_sd_initFlag = 0;

// С, λֽ
u16 SD_BLOCKSIZE = 512; 

extern u32 sdCardByteSize;
DSTATUS SD_disk_status()
{
    if (!diskio_sd_initFlag)
        return RES_ERROR;
    return RES_OK;
};

DSTATUS SD_disk_initialize()
{
    diskio_sd_initFlag = 0;
    if (SD_Init() == 0)
    {
        diskio_sd_initFlag = 1;
        return RES_OK;
    }
    return RES_ERROR;
};

DSTATUS SD_disk_read(BYTE *buff, LBA_t sector, UINT count)
{
    BYTE *srcBuff = buff;
    if (!diskio_sd_initFlag)
        return RES_ERROR;
    while (count > 0 && count--)
    {
        SD_ReadSingleBlock(sector * SD_BLOCKSIZE, buff);
        sector++;
        buff += SD_BLOCKSIZE;
    }
    // if (sector - 1 == 0 || sector - 1 == 63)
    // {
    //     printf("SD_disk_read:%lu:\n",sector-1);
    //     printBuffer(srcBuff);
    // }
    return RES_OK;
};

DSTATUS SD_disk_write(const BYTE *buff, LBA_t sector, UINT count)
{
    // if (sector == 0 || sector == 63)
    // {
    //     printf("SD_disk_write:%lu,%u\n",sector,count);
    //     printBuffer(buff);
    // }
    while (count > 0 && count--)
    {
        SD_WriteSingleBlock(sector * SD_BLOCKSIZE, buff);
        sector++;
        buff += SD_BLOCKSIZE;
    }
    return RES_OK;
};

DSTATUS SD_disk_ioctl(BYTE cmd, void *buff)
{
    switch (cmd)
    {
    case CTRL_SYNC:
        return RES_OK;
    case GET_SECTOR_COUNT:
        *(DWORD *)buff = (DWORD)sdCardByteSize / (DWORD)SD_BLOCKSIZE; // 
        return RES_OK;
    case GET_SECTOR_SIZE:
        *(WORD *)buff = SD_BLOCKSIZE; // С
        return RES_OK;
    case GET_BLOCK_SIZE:
        *(DWORD *)buff = 1; // ΪλĴشС, ĬΪ1, ʽʱʹ.
        return RES_OK;
    }

    //    switch (cmd)
    //    {
    //        // Get R/W sector size (WORD)
    //        case GET_SECTOR_SIZE :
    //            *(WORD * )buff = SD_BLOCKSIZE;
    //        break;
    //        // Get erase block size in unit of sector (DWORD)
    //        case GET_BLOCK_SIZE :
    //            *(DWORD * )buff = SD_DiskSize;
    //        break;

    //        case GET_SECTOR_COUNT:
    //            *(DWORD * )buff = SDCardInfo.CardCapacity/SDCardInfo.CardBlockSize;
    //            break;
    //        case CTRL_SYNC :
    //        break;
    //        default:
    //            return RES_PARERR;
    //    }
    return RES_OK;
};
