#include "def.h"
#include "diskio_W25QXX.h"
#include "w25qxx.h"
// #include "APP_DMA_SPI_Flash.h"
#include "stdio.h"
static u32 DiskSize = 0;

void printBuffer(BYTE *buff)
{
    int i = 0;
    for (i = 0; i < 16; i++)
    {
        printf("%02X ", buff[i]);
    }
    printf("...");
    for (i = 500; i < 512; i++)
    {
        printf("%02X ", buff[i]);
    }
    printf("\n");
}
DSTATUS W25QXX_disk_status()
{
    //printf("W25QXX_disk_status\n");
    if (DiskSize)
    {
        return RES_OK;
    }
    return RES_ERROR;
};

DSTATUS W25QXX_disk_initialize()
{
    DiskSize = W25QXX_INIT();
    //printf("W25QXX_disk_initialize DiskSize:%lu\n", DiskSize);
    if (DiskSize)
    {
        return RES_OK;
    }
    return RES_ERROR;
};

DSTATUS W25QXX_disk_read(BYTE *buff, LBA_t sector, UINT count)
{
    BYTE *srcBuff = buff;
    //printf("W25QXX_disk_read:%lu,%u\n",sector,count);
    while (count > 0 && count--)
    {
        W25QXX_Read(sector * 512ul, buff, 512);
        sector++;
        buff += 512;
    }
    if (sector - 1 == 0 || sector - 1 == 63)
    {
        //printf("W25QXX_disk_read:%lu:\n",sector-1);
        //printBuffer(srcBuff);
    }
    return RES_OK;
};
extern void testReadNBytes(u32 addr, u8 j);
u8 xdata testBuff[512];
DSTATUS W25QXX_disk_write(const BYTE *buff, LBA_t sector, UINT count)
{

    if (sector == 0 || sector == 63)
    {
        //printf("W25QXX_disk_write:%lu,%u\n",sector,count);
        //printBuffer(buff);
    }

    while (count > 0 && count--)
    {
        W25QXX_Write(sector * 512ul, buff, 512);
        // // testReadNBytes(sector*512ul,12);
        // W25QXX_Read(sector * 512ul, testBuff, 512);
        // //printBuffer(testBuff);
        sector++;
        buff += 512;
    }

    return RES_OK;
};

DSTATUS W25QXX_disk_ioctl(BYTE cmd, void *buff)
{
    switch (cmd)
    {
    case CTRL_SYNC:
        return RES_OK;
    case GET_SECTOR_COUNT:
        *(DWORD *)buff = (DWORD)DiskSize / 512ul; // 
        return RES_OK;
    case GET_SECTOR_SIZE:
        *(WORD *)buff = 512; // С
        return RES_OK;
    case GET_BLOCK_SIZE:
        *(DWORD *)buff = 1; // ΪλĴشС, ĬΪ1, ʽʱʹ.
        return RES_OK;
    }
    return RES_ERROR;
};
