#include "config.h"
#include "user.h"
#include "user_test.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"

#include "SD.c"
#include "w25qxx.c"

//Լ
#include "user_gpio_test.c"
#include "user_w25q_test.c"
#include "user_sd_test.c"
#include "user_fatfs.c"

bit initFlag;
bit p35Flag;
bit P47Flag;
bit INT0Flag;
bit F1MS;
bit F1S;

u16 testNumber;
u8 xdata DmaTxBuffer[256] __attribute__((aligned (4)));
u8 xdata DmaRxBuffer[256] __attribute__((aligned (4)));

void printMenu(){
	printf("***************************AiCubeTest***************************\n");
	printf("˵:P35,P33жϲ,CDCָ:\n");
	printf("P:ӡ˵\n");
	printf("T1:P0Ʋ\n");
	printf("T2:Ź\n");
	printf("T3:W25Q\n");
	printf("T4:SD\n");
	printf("T5:W25Q_FatFs\n");
	printf("T6:SD_FatFs\n");
	printf("****************************************************************\n");
}

void processUsbData(u8* buffer,BYTE len){	
	testNumber = 0;
	if(len >= 2 && buffer[0] == 'T'){
		sscanf(buffer,"T%u",&testNumber);
		printf("Test:%u\n",testNumber);
		memset(UsbOutBuffer,0,sizeof(UsbOutBuffer));
	}else if(buffer[0] == 'P'){
		printMenu();
	}else{
		USB_SendData(buffer, len);
	}
};

void userInit(){
	//ֹUSBԶʧЧ
	P3M0 &= ~0x03;
    P3M1 |= 0x03;

	initFlag = 0;
	INT0Flag = 0;
	p35Flag = 0;
	P47Flag = 0;
	testNumber = 0;
	P40 = 0;
	F1MS = 0;
	F1S = 0;
	P0 = 0x0F;
	delay_ms(2000);
	if(DeviceState == DEVSTATE_CONFIGURED){
		printMenu();
	}
}
void wdtTest(){
	//Źʼ
	WDT_IdlePause();                    //CPUIDLEģʽʱŹͣ
    WDT_SetPrescale256();               //ÿŹʱԤƵ
    WDT_Enable();                       //ʹܿŹ
	
	WDT_Clear();                    //忴Źʱ
	
	while(1){
		printf("WDT Test:ιȸλ!\n");
		delay_ms(500);
	}
}
void processIsr(){
	if(INT0Flag){
		printf("INT1 Interrupt\r\n");
		INT0Flag = 0;
	}
	if(p35Flag){
		printf("P3.5½ж\r\n");
		p35Flag = 0;
	}
	if(P47Flag){
		P47Flag = 0;
		printf("P4.7½ж\r\n");
		delay_ms(10);
		// USB 
		USBCON = 0x00;
		USBCLK = 0x00;
		IRC48MCR = 0x00;
		delay_ms(10);
		//λ
		IAP_CONTR = 0x20;
	}
}
void processTest(){
	if(DeviceState != DEVSTATE_CONFIGURED){
		if(F1S){
			F1S = 0;
			P0 = ~P0;
		}	
		return;
	}
	processIsr();
	if(!testNumber){
		return;
	}
	switch(testNumber){
			case 1:
				gpioTest();
				break;
			case 2:
				wdtTest();
				break;
			case 3:
				w25qTest();
				break;
			case 4:
				sdTest();
				break;
			case 5:
				fatFsTest(FATFS_W25Q_PATH);
				break;
			case 6:
				fatFsTest(FATFS_SD_PATH);
				break;
			default:
				break;
	}
	testNumber = 0;
};