#include "ff.c"
#include "ffsystem.c"
#include "ffunicode.c"
#include "diskio.c"
#include "diskio_SD.c"
#include "diskio_W25QXX.c"
#include "SD.h"
#include "w25qxx.h"
#include "spi.h"
#include "stdio.h"
FATFS xdata fs; // ̹
FIL xdata file; // ļ
//#define USB_SD_TEST 1

#define FATFS_SD_PATH "SD:"
#define FATFS_W25Q_PATH "W25Q:"

// ַƴӺ
char * str_concat(const char *dest, const char *src) {
    static char buffer[FF_MAX_LFN];
    memset(buffer, 0, sizeof(buffer));
    strcpy(buffer, dest);
    strcat(buffer, src);
    return buffer;
}

/*---------------------------------------------------------
ȡ̴Сʹ
----------------------------------------------------------*/
void GetDiskInfo(const char *rootPath)
{
  FATFS *pfs;
  u32 total, used, free;
  BYTE fs_type;
  const char *fs_type_str;

  f_getfree(rootPath, &free, &pfs);
  total = (pfs->n_fatent - 2) * pfs->csize; // 
  free *= pfs->csize;                       // 
  used = total - free;                      // ʹ

  // ʹתΪٷֱ
  used = used * 100ul / total;

  // λתΪKB,ȳС,ٳ1024
  total = total * 512ul / 1024ul;

  // ȡļϵͳ
  fs_type = fs.fs_type;
  switch (fs_type)
  {
  case FS_FAT12:
    fs_type_str = "FAT12";
    break;
  case FS_FAT16:
    fs_type_str = "FAT16";
    break;
  case FS_FAT32:
    fs_type_str = "FAT32";
    break;
  default:
    fs_type_str = "Unknown";
    break;
  }

  // ӡļϵͳϢ
  printf("File System Information:\n");
  printf("File System Type: %s\n", fs_type_str);

  // ӡʱMBΪλ,ٴγ1024ֱС
  printf(": %lu.%.3lu MB  ʹ: %lu%%\n\n", total / 1024ul, total % 1024ul * 1000ul / 1024ul, used);
}

/*---------------------------------------------------------
ʾFATFS 
----------------------------------------------------------*/
// жָ·ǷΪļ
u8 is_file(const char* path) {
    FILINFO fno;
    FRESULT res;

    // ȡļϢ
    res = f_stat(path, &fno);
    if (res != FR_OK) {
        // ȡļϢʧܣļ
        return 0;
    }

    // ǷΪĿ¼
    if (fno.fattrib & AM_DIR) {
        // Ŀ¼ļ
        return 0;
    }

    // Ŀ¼ļ
    return 1;
}


void fatFsTest(const char* rootPath)
{
  u16 br, bw;

  u8 retryTimes = 2;
  u8 xdata text[33];
  FRESULT res;
  // ĬϸʽΪFAT16
  // FAT32ļϵͳСΪ512MB
  MKFS_PARM defopt = {FM_ANY, 0, 0, 0, 0};
  text[32] = '\0';

  

  // , ÿϵ綼ʽ, ˾ע
  // res = f_mkfs(FATFS_PATH, 0, &file.buf[0], FF_MAX_SS );   //ʽ,Զ
  // printf("ʽ:%u\n",res );
    
  while (1)
  { // ش
    
    res = f_mount(&fs, rootPath, 1);
    if (res)
    {
        printf("شʧܣ%u\n", res);
      if(retryTimes){
        retryTimes--;
        printf("¸ʽ!\n");
        res = f_mkfs(rootPath, &defopt, &file.buf[0], FF_MAX_SS); // ʽ,Զ
        printf("ʽ:%u\n", res);
      }else{    
        printf("ʧ.\n");
        return;
      }
    }
    else
    {
      printf("f_mount:%u\n", res);
      break;
    }
    
  }
  printf("ѹش\n");

  GetDiskInfo(rootPath); // ӡʹ;
  if(is_file(str_concat(rootPath,"/abc.txt"))){
    f_open(&file, str_concat(rootPath,"/abc.txt"), FA_READ);
    printf("´ļȡļ\n\n");
    f_read(&file, &text[0], 32, &br);
    printf("ļΪ: ");
    printf(text);
    printf("\n\n");
    f_close(&file);
  }
  

  if (f_open(&file, str_concat(rootPath,"/abc.txt"), FA_READ | FA_WRITE | FA_OPEN_ALWAYS))
  { // һļ,ļ򴴽һµļ
    printf("ļʧ!\n");
    while (1)
      ;
  }
  printf("ļabc.txt\n");

  f_lseek(&file, 0);
  f_truncate(&file);
  f_write(&file, "FATFS@AI8051U DEMO", sizeof("FATFS@AI8051U DEMO"), &bw); // ַдļ
  printf("дַ: \"FATFS@AI8051U DEMO\"\n");
  f_close(&file);

  f_open(&file, str_concat(rootPath,"/abc.txt"), FA_READ);
  printf("´ļȡļ\n\n");
  f_read(&file, &text[0], 32, &br);
  printf("ļΪ: ");
  printf(text);
  printf("\n\n");
  f_close(&file);

  f_mount(0, "", 0);
  printf("DEMO END");
}
