#include "config.h"
#include "sd.h"
#include "spi.h"
#include "port.h"

extern u8 xdata DmaTxBuffer[256];
extern u8 xdata DmaRxBuffer[256];
int16 sdTestTimes = 0;
void sdTestInit(){
    
}
void sdWriteTest(u32 addr){

    u16 i;
    sdTestTimes++;
    for (i = 0; i < 512; i++)
    {
        DmaTxBuffer[i] = i+sdTestTimes;
    }
    printf("SD_WriteSingleBlock\n");
    SD_WriteSingleBlock(addr, DmaTxBuffer);

    memset(DmaRxBuffer, 0, 512);
    printf("SD_ReadSingleBlock\n");
    SD_ReadSingleBlock(addr, DmaRxBuffer);

    for (i = 0; i < 512; i++)
    {
        if (i % 16 == 0)
        {
            printf("\n");
        }
        printf("%02X ", DmaRxBuffer[i]);
        if(DmaRxBuffer[i] != DmaTxBuffer[i]){
            printf("error\n");
            return;
        }
    }
    printf("\n");
}
void sdTest()
{
    u8 ret;
    u32 sdSize;
    if(sdTestTimes == 0){
        ret = SD_Init();
        printf("SD_Test:%u\n", ret);
        if (ret)
        {
            return;
        }

        sdSize = SD_ReadCapacity();
        printf("sdSize:%lu\n", sdSize);
    }
    
    sdWriteTest(63*512);
    //sendCmd41();
    //delay_ms(1000);
    sdWriteTest(0);
    //delay_ms(1000);
    //sendCmd41();
    
}