#include "config.h"
#include "w25qxx.h"
#include "spi.h"
#include "port.h"

extern u8 xdata DmaTxBuffer[256];
extern u8 xdata DmaRxBuffer[256];

extern u8  B_FlashOK;
extern bit	SpiTxFlag;

void w25qTestInit(){
    SPI_Init();

    CLR_REG_BIT(HSSPI_CFG2, HSSPICFG2_IOSW_MSK);
    SPI_SwitchP4n();
    DMA_SPI_SetRxAddress(DmaRxBuffer);
    DMA_SPI_SetTxAddress(DmaTxBuffer);
    SPI_SCK = 0;    // set clock to low initial state
    SPI_SI = 1;

    FlashCheckID();
    FlashCheckID();
}

/************************************************************************
nֽ,ָݽбȽ, 󷵻1,ȷ0
************************************************************************/
u8 SPI_DMA_Read_Compare(u16 size)
{
    u8  j=0;
    if(size == 0)   return 2;
    if(!B_FlashOK)  return 2;
    while(SpiTxFlag);                         //DMAæ

    do
    {
        if(DmaRxBuffer[j] != DmaTxBuffer[j])       //receive byte and store at buffer
        {
            return 1;
        }
        j++;
    }while(--size);         //read until no_bytes is reached
    return 0;
}
void w25qTest(){
    u32 Flash_addr;
    u8 i,j;
    w25qTestInit();
    Flash_addr = 0;
    j = 16;
    for (i = 0; i < j; i++)
    {
        DmaTxBuffer[i] = i;
    }
    
    FlashSectorErase(Flash_addr);
    printf("Ѳһ!\r\n");
    SPI_DMA_Write_Nbytes(Flash_addr,j);     //дNֽ 
    SPI_DMA_Read_Nbytes(Flash_addr,j);
    i = SPI_DMA_Read_Compare(j); //Ƚд
    if(i == 0)
    {
        printf("д%uֽ!\r\n",(u16)j);
    }
    else printf("д!\r\n");
    printf("DmaRxBuffer:\n");
    for (i = 0; i < j; i++)
    {
        printf("%02x ",DmaRxBuffer[i]);
    }
    printf("\n");
}