/*---------------------------------------------------------
w25qxx.c 
----------------------------------------------------------*/

#include "w25qxx.h"
#include "string.h"
#include "config.h"
#include "spi.h"


   

static u32         Cache_addr;      //ݶӦַ
u8 xdata    CacheBufS[4096] __attribute__((aligned (4))); //
u8 xdata    CacheBufP[4096] __attribute__((aligned (4)));  //
static u8          Cache_Flag;      //1ʾδд


u8 CheckFlashBusy();
void SPI_DMA_Read2Buffer(u32 addr, u8 *buf, u16 size);
void SPI_DMA_Write_Sector(u32 addr,u8 *buf);

//========================================================================
//                               ر
//========================================================================

u8  B_FlashOK;              //Flash״̬
u8  FLASH_ID, FLASH_ID1, FLASH_ID2;

extern bit SpiTxFlag;
extern u8 xdata DmaTxBuffer[256];
extern u8 xdata DmaRxBuffer[256];

void Delay100us(void)	//@40.000MHz
{
	unsigned char data i, j;

	i = 6;
	j = 47;
	do
	{
		while (--j);
	} while (--i);
}
void ReadReg01(){
    u8 r1,r2,r3;	
	SPI_CE  = 0;
    SPI_WriteByte(SFC_RDSR);
    SPI_WriteByte(0x00);
    r1 = SPI_ReadByte();     
	SPI_CE  = 1;
	Delay100us();
	SPI_CE  = 0;
    SPI_WriteByte(0x35);
    SPI_WriteByte(0x00);
    r2 = SPI_ReadByte();    
	SPI_CE  = 1;
	Delay100us();
	SPI_CE  = 0;
		SPI_WriteByte(0x15);
    SPI_WriteByte(0x00);
    r3 = SPI_ReadByte();    	
  SPI_CE  = 1;  

    printf("r=0x%02x,0x%02x,0x%02x\r\n",r1,r2,r3);
}

void FlashCheckID(void)
{
    ReadReg01();
	
    SPI_CE  = 0;
    SPI_WriteByte(SFC_RDID);        //ͶȡID
    SPI_WriteByte(0x00);            //ն3ֽ
    SPI_WriteByte(0x00);
    SPI_WriteByte(0x00);
    FLASH_ID1 = SPI_ReadByte();     //ȡID1
    FLASH_ID  = SPI_ReadByte();     //ȡ豸ID
    FLASH_ID2 = SPI_ReadByte();     //ȡID2
    SPI_CE  = 1;

    printf("ID1=0x%02x,ID=0x%02x,ID2=0x%02x\r\n",FLASH_ID1,FLASH_ID,FLASH_ID2);

    if((FLASH_ID1 == 0x9d) && (FLASH_ID2 == 0x7f))  B_FlashOK = 1;  //ǷΪPM25LVxxϵеFlash
    else if(FLASH_ID == 0x12)  B_FlashOK = 2;                       //ǷΪW25X4xϵеFlash
    else if(FLASH_ID == 0x13)  B_FlashOK = 3;                       //ǷΪW25X8xϵеFlash
    else if(FLASH_ID == 0x17)  B_FlashOK = 4;                       //ǷΪW25X128ϵеFlash
    else                                            B_FlashOK = 0;
}

/************************************************
Flashжȡ
ڲ:
    addr   : ַ
    buffer : Flashжȡ
    size   : ݿС
ڲ:
    
************************************************/
void SPI_DMA_Read_Nbytes(u32 addr, u16 size)
{
    if(size == 0)   return;
    if(!B_FlashOK)  return;
    while(SpiTxFlag);                     //DMAæ
    while(CheckFlashBusy() > 0);        //Flashæ

    SPI_CE  = 0;                        //enable device
    SPI_WriteByte(SFC_READ);            //read command

    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
    
    DMA_SPI_SetRxAddress(DmaRxBuffer);
    SpiTxFlag = 1;
    DMA_SPI_SetAmount(size-1);    //ôֽn+1
    DMA_SPI_MasterTrigger();           //ʼSPI_DMAģʽ
}
void SPI_DMA_Read2Buffer(u32 addr, u8 *buf, u16 size){
    //printf("SPI_DMA_Read2Buffer:%lu,%lu,%u\n",addr,(u32)buf,size);	
    if(size == 0)   return;
    if(!B_FlashOK)  return;
    while(SpiTxFlag);                     //DMAæ
    while(CheckFlashBusy() > 0);        //Flashæ
	
    SPI_CE  = 0;                        //enable device
    SPI_WriteByte(SFC_READ);            //read command

    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
	
    // DMA_SPI_RXAH = (u16)buf >> 8;   //SPIݴ洢ַ
    // DMA_SPI_RXAL = (u16)buf;
    DMA_SPI_SetRxAddress(buf);
    SpiTxFlag = 1;
    DMA_SPI_SetAmount((size-1));    //ôֽn+1
    DMA_SPI_MasterTrigger();           //ʼSPI_DMAģʽ
    while(SpiTxFlag);
    SPI_CE  = 1;
    //printBuffer(buf);
}


/************************************************
ʹFlashд
ڲ: 
ڲ: 
//
************************************************/
void FlashWriteEnable(void)
{
    while(CheckFlashBusy() > 0);    //Flashæ
    SPI_CE  = 0;
    SPI_WriteByte(SFC_WREN);        //дʹ
    SPI_CE  = 1;
}


/************************************************
, һ4KB
ڲ: 
ڲ: 
************************************************/
void FlashSectorErase(u32 addr)
{
    if(B_FlashOK)
    {
        FlashWriteEnable();     //ʹFlashд
      SPI_CE  = 0;
        if(B_FlashOK == 1)
        {
            SPI_WriteByte(SFC_SECTORER1);   //
        }
        else
        {
            SPI_WriteByte(SFC_SECTORER2);   //
        }
        SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
        SPI_WriteByte(((u8 *)&addr)[2]);
        SPI_WriteByte(((u8 *)&addr)[3]);
        SPI_CE  = 1;
    }
}

/************************************************
дݵFlash
ڲ:
    addr   : ַ
    size   : ݿС
ڲ: 
************************************************/
void SPI_DMA_Write_Nbytes(u32 addr, u16 size)
{
    if(size == 0)   return;
    if(!B_FlashOK)  return;
    while(SpiTxFlag);                     //DMAæ
    while(CheckFlashBusy() > 0);        //Flashæ

    FlashWriteEnable();                 //ʹFlashд

    SPI_CE  = 0;                        //enable device
    SPI_WriteByte(SFC_PAGEPROG);        // ҳ
    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
    
    DMA_SPI_SetTxAddress(DmaTxBuffer);
    SpiTxFlag = 1;
    DMA_SPI_SetAmount(size-1);    //ôֽn+1
    DMA_SPI_MasterTrigger();           //ʼSPI_DMAģʽ
}
void SPI_DMA_Write_Sector(u32 addr,u8 *buf){
		u8 i;
		
    if(buf == NULL)   return;
    if(!B_FlashOK)  return;
    while(SpiTxFlag);                     //DMAæ
    while(CheckFlashBusy() > 0);        //Flashæ
	
		FlashSectorErase(addr);
		for(i=0;i<16;i++){
			FlashWriteEnable();
			SPI_CE  = 0;
			
			SPI_WriteByte(SFC_PAGEPROG);        // ҳ
			SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
			SPI_WriteByte(((u8 *)&addr)[2]);
			SPI_WriteByte(((u8 *)&addr)[3]);
			
			
			// DMA_SPI_TXAH = (u16)buf >> 8;   //SPIݴ洢ַ
			// DMA_SPI_TXAL = (u16)buf;
            DMA_SPI_SetTxAddress(buf);
			SpiTxFlag = 1;
			DMA_SPI_SetAmount(256-1);    //ôֽn+1
			DMA_SPI_MasterTrigger();           //ʼSPI_DMAģʽ
			while(SpiTxFlag);
			SPI_CE  = 1;
			buf+=256;
			addr+=256;
		}
}
/************************************************
Flashæ״̬
ڲ: 
ڲ:
    0 : Flashڿ״̬
    1 : Flashæ״̬
************************************************/
u8 CheckFlashBusy(void)
{
    u8  dat;

    SPI_CE  = 0;
    SPI_WriteByte(SFC_RDSR);        //Ͷȡ״̬
    dat = SPI_ReadByte();           //ȡ״̬
    SPI_CE  = 1;
    return (dat);                   //״ֵ̬Bit0Ϊæ־
}

u32 getFlashSize(u8 isPrint){
    u8 a,b,c;
    if(!B_FlashOK) {
        if(isPrint){
            printf("getFlashSize error.\n");
        }
        return 0;
    }	
    SPI_CE  = 0;
    SPI_WriteByte(SFC_RDJID);        //ͶȡID
    
    a = SPI_ReadByte();     //Manufacturer ID (EFh)
    b = SPI_ReadByte();     //Memory Type ID
    c = SPI_ReadByte();     //Capacity ID
    SPI_CE  = 1;
		if(isPrint){
			printf("getFlashSize=0x%02x,ID=0x%02x,ID2=0x%02x\r\n",a,b,c);
		}
		if(a == 0xef){
				return 1ul <<  c;
		}
    return 0;
}

/*---------------------------------------------------------
//æ
----------------------------------------------------------*/
 void Busy_Wait(void)
{
	while(CheckFlashBusy() > 0);
}
/*---------------------------------------------------------
Flash
----------------------------------------------------------*/
static void Read_Flash(u32 addr, u8 *buf, u16 Size)
{
	//printf("Read_Flash:%lu,%lu,%u\n",addr,(u32)buf,Size);	
   SPI_DMA_Read2Buffer(addr,buf,Size);
	 
}

static bit fFlashOK = 0;
u32 xdata MemorySize;
extern void w25qTestInit();
u32  W25QXX_INIT(void){
	
	if ( fFlashOK ) return MemorySize;
        
	w25qTestInit();
	MemorySize = getFlashSize(0);
	if( MemorySize ) {
		
		fFlashOK = 1;
		Cache_addr=0;                               //ǰӦ
		Cache_Flag=0;                               //0ʾûδд
		//testReadNBytes(Cache_addr,12);
		Read_Flash(Cache_addr,CacheBufS,4096);      //仺
	}
	return MemorySize;
};

u32     W25QXX_Get_MemorySize(void){
	return getFlashSize(0);
};
/*---------------------------------------------------------
д
----------------------------------------------------------*/
void Write_Sector(u32 addr, u8 *buf)
{
    SPI_DMA_Write_Sector(addr,buf);
}
extern void printBuffer(BYTE*buff);
void    W25QXX_Read(u32 addr, u8 *buf, u32 Size){
    u32 sector,addr1;
    u16 number;
		u8 *srcBuf;
		srcBuf = buf;
		//printf("W25QXX_Read:%lu,%lu,%u\n",addr,(u32)buf,Size);	
    while(Size){
        sector = addr&~4095;    //ַ
        if(sector == Cache_addr){
            addr1 = addr&4095;          //ƫ
            number = 4096-addr1;        //ǰʣռ
            if(number>Size)number=Size; //ʵʲ
            memcpy(buf,&CacheBufS[addr1],number);
					//printf("W25QXX_Read:%d\n",__LINE__);
        }else{
            addr1 = addr&255;           //ҳƫ
            number = 256-addr1;         //ǰҳʣռ
            if(number>Size)number=Size; //ʵʲ
            Read_Flash(addr,CacheBufP,number);  //
            memcpy(buf,CacheBufP,number);
					//printf("W25QXX_Read:%d\n",__LINE__);
        }
        addr+=number;
        buf+=number;
        Size-=number;
    }
		//printBuffer(srcBuf);
};

void    W25QXX_Write(u32 addr, u8 *buf, u32 Size){
    u32 sector,addr1;
    u16 number;
    
    while(Size){
        sector = addr&~4095;        //ַ   
        if(sector != Cache_addr){
						//printf("W25QXX_Write:%lu,%lu,%u\n",addr,(u32)buf,Size);	
            if(Cache_Flag){
                Write_Sector(Cache_addr,CacheBufS); //дFLASH
                Cache_Flag=0;       //0ʾûδд
            }
            Read_Flash(sector,CacheBufS,4096);  //ػ
            Cache_addr = sector;
        }
        addr1 = addr&4095;          //ƫ
        number = 4096-addr1;        //ǰʣռ
        if(number>Size)number=Size; //ʵʲ
        memcpy(&CacheBufS[addr1],buf,number);
        addr+=number;
        buf+=number;
        Size-=number;
        Cache_Flag=1;               //1ʾδд
    }
};

void    W25QXX_WriteCache(void){
    if(Cache_Flag){
        Write_Sector(Cache_addr,CacheBufS); //дFLASH
        Cache_Flag=0;           //0ʾûδд
    }
};


///*---------------------------------------------------------
//ID
//----------------------------------------------------------*/
//u8 W25QXX_Get_ID(void)
//{
//    u8 a;
//    SPI_CS=0;
//    SPI_shift(SFC_RDID);
//    SPI_shift(0);
//    SPI_shift(0);
//    SPI_shift(0);
//    a=SPI_shift(0);
//    SPI_CS=1;
//    return a;
//}
//extern void SPI_WriteByte(u8 dat);
//extern u8 SPI_ReadByte(void);
//u8 FLASH_ID1,FLASH_ID,FLASH_ID2;
//void FlashCheckID(void)
//{
//	
//    SPI_CS  = 0;
//    SPI_WriteByte(SFC_RDID);        //ͶȡID
//    SPI_WriteByte(0x00);            //ն3ֽ
//    SPI_WriteByte(0x00);
//    SPI_WriteByte(0x00);
//    FLASH_ID1 = SPI_ReadByte();     //ȡID1
//    FLASH_ID  = SPI_ReadByte();     //ȡ豸ID
//    FLASH_ID2 = SPI_ReadByte();     //ȡID2
//    SPI_CS  = 1;

//    printf("ID1=0x%02x,ID=0x%02x,ID2=0x%02x\r\n",FLASH_ID1,FLASH_ID,FLASH_ID2);

////    if((FLASH_ID1 == 0x9d) && (FLASH_ID2 == 0x7f))  B_FlashOK = 1;  //ǷΪPM25LVxxϵеFlash
////    else if(FLASH_ID == 0x12)  B_FlashOK = 2;                       //ǷΪW25X4xϵеFlash
////    else if(FLASH_ID == 0x13)  B_FlashOK = 3;                       //ǷΪW25X8xϵеFlash
////    else if(FLASH_ID == 0x17)  B_FlashOK = 4;                       //ǷΪW25X128ϵеFlash
////    else                                            B_FlashOK = 0;
//}
///*---------------------------------------------------------
// MemorySize
//----------------------------------------------------------*/
//u32 W25QXX_Get_MemorySize(void)
//{
//    u8 id, jid;
//    u32 MemorySize = 0;
//		u8  B_FlashOK;
//    FlashCheckID();
//		if((FLASH_ID1 == 0x9d) && (FLASH_ID2 == 0x7f))  B_FlashOK = 1;  //ǷΪPM25LVxxϵеFlash
//    else if(FLASH_ID == 0x12)  B_FlashOK = 2;                       //ǷΪW25X4xϵеFlash
//    else if(FLASH_ID == 0x13)  B_FlashOK = 3;                       //ǷΪW25X8xϵеFlash
//    else if(FLASH_ID == 0x17)  B_FlashOK = 4;                       //ǷΪW25X128ϵеFlash
//    else                                            B_FlashOK = 0;
//		if(!B_FlashOK){
//			return 0;
//		}
//		switch(B_FlashOK){
//			case 4:
//				return 128*1024*1024;
//			default:
//				return 0;
//		}
//  //  if ( (id<0x10) || (id>0x17) ) return 0;  // 128KB  16MB ֮ͺЧ
////    SPI_CS=0;
////    SPI_shift(SFC_RDJID);
////    SPI_shift(0);
////    SPI_shift(0);
////    jid=SPI_shift(0);
////    SPI_CS=1;
////  printf("SFC_RDJID:%u\n",jid);  
////    if ( jid != (id+1) ) return 0;          //JID Ǳ ID 1
////    
////    return 1ul << jid;
//}

///************************************************
//Flashæ״̬
//ڲ: 
//ڲ:
//    0 : Flashڿ״̬
//    1 : Flashæ״̬
//************************************************/
//u8 CheckFlashBusy(void)
//{
//    u8  dat;

//    SPI_CS  = 0;
//    SPI_WriteByte(SFC_RDSR);        //Ͷȡ״̬
//    dat = SPI_ReadByte();           //ȡ״̬
//    SPI_CS  = 1;

//    return (dat);                   //״ֵ̬Bit0Ϊæ־
//}

///*---------------------------------------------------------
////æ
//----------------------------------------------------------*/
//static void Busy_Wait(void)
//{
//	while(CheckFlashBusy() > 0);
////    u8 state;
////    while(1){
////        SPI_CS=0;
////        SPI_shift(SFC_RDSR);
////        state=SPI_shift(0);
////        SPI_CS=1;
////        if(!state)break;
////    }
//}
///*---------------------------------------------------------
//дʹ
//----------------------------------------------------------*/
//static void WriteEnable(void)
//{
//    Busy_Wait();        //æ
//    SPI_CS=0;
//    SPI_shift(SFC_WREN);
//    SPI_CS=1;
//}

///*---------------------------------------------------------
//д
//----------------------------------------------------------*/
//static void Write_Sector(u32 addr, u8 *buf)
//{
//    u8 i;
//    
//    WriteEnable();              //дʹ
//    SPI_CS=0;
//    SPI_shift(SFC_SECTORER);       //
//    SPI_shift((u8)(addr>>16));
//    SPI_shift((u8)(addr>>8 ));
//    SPI_shift((u8)(addr>>0 ));
//    SPI_CS=1;
//    
//    for(i=0;i<16;i++){
//        WriteEnable();                  //дʹ
//        SPI_CS=0;
//        SPI_shift(SFC_PAGEPROG);           //ҳ
//        SPI_shift((u8)(addr>>16));
//        SPI_shift((u8)(addr>>8 ));
//        SPI_shift((u8)(addr>>0 ));
//        SPI_DMA_Write(buf,256);
//        buf+=256;
//        addr+=256;
//        SPI_CS=1;
//    }
//}

///*---------------------------------------------------------
//Flash
//----------------------------------------------------------*/
//static void Read_Flash(u32 addr, u8 *buf, u16 Size)
//{
//    Busy_Wait();        //æ
//    SPI_CS=0;
//    SPI_shift(SFC_READ);          
//    SPI_shift((u8)(addr>>16));
//    SPI_shift((u8)(addr>>8 ));
//    SPI_shift((u8)(addr>>0 ));
//    SPI_DMA_Read(buf,Size);
//    SPI_CS=1;
//}


///*---------------------------------------------------------
////,
//----------------------------------------------------------*/
//void W25QXX_Read(u32 addr, u8 *buf, u32 Size)
//{
//    u32 sector,addr1;
//    u16 number;

//    while(Size){
//        sector = addr&~4095;    //ַ
//        if(sector == Cache_addr){
//            addr1 = addr&4095;          //ƫ
//            number = 4096-addr1;        //ǰʣռ
//            if(number>Size)number=Size; //ʵʲ
//            memcpy(buf,&CacheBufS[addr1],number);
//        }else{
//            addr1 = addr&255;           //ҳƫ
//            number = 256-addr1;         //ǰҳʣռ
//            if(number>Size)number=Size; //ʵʲ
//            Read_Flash(addr,CacheBufP,number);  //
//            memcpy(buf,CacheBufP,number);
//        }
//        addr+=number;
//        buf+=number;
//        Size-=number;
//    }
//}

///*---------------------------------------------------------
////Ϊ˼СڴʹСдЧ, дʹһӳд, жW25QXXĲɺ, Ӧһα, ʹд
//----------------------------------------------------------*/
//void W25QXX_WriteCache(void)
//{
//    if(Cache_Flag){
//        Write_Sector(Cache_addr,CacheBufS); //дFLASH
//        Cache_Flag=0;           //0ʾûδд
//    }
//}

///*---------------------------------------------------------
////д,
//----------------------------------------------------------*/
//void W25QXX_Write(u32 addr, u8 *buf, u32 Size)
//{
//    u32 sector,addr1;
//    u16 number;
//    
//    while(Size){
//        sector = addr&~4095;        //ַ   
//        if(sector != Cache_addr){
//            if(Cache_Flag){
//                Write_Sector(Cache_addr,CacheBufS); //дFLASH
//                Cache_Flag=0;       //0ʾûδд
//            }
//            Read_Flash(sector,CacheBufS,4096);  //ػ
//            Cache_addr = sector;
//        }
//        addr1 = addr&4095;          //ƫ
//        number = 4096-addr1;        //ǰʣռ
//        if(number>Size)number=Size; //ʵʲ
//        memcpy(&CacheBufS[addr1],buf,number);
//        addr+=number;
//        buf+=number;
//        Size-=number;
//        Cache_Flag=1;               //1ʾδд
//    }
//}

//static bit fFlashOK = 0;
///*------------------------------------------------------------------------------
////ʼW25QXX, ֵΪ MemorySize, δʶͺ, 򷵻 0
//------------------------------------------------------------------------------*/
//u32 W25QXX_INIT(void)
//{
//    u32 MemorySize;
//    
//    if ( fFlashOK ) return W25QXX_Get_MemorySize();
//        
//    //My_SPI_init();
//    //delay_ms(10);
//    MemorySize = W25QXX_Get_MemorySize();
//    
//    if( MemorySize ) {
//        fFlashOK = 1;
//        Cache_addr=0;                               //ǰӦ
//        Cache_Flag=0;                               //0ʾûδд
//        Read_Flash(Cache_addr,CacheBufS,4096);      //仺
//    }
//    
//    return MemorySize;
//}




