/*---------------------------------------------------------
w25qxx.h
----------------------------------------------------------*/
#ifndef __W25Q32_H_
#define __W25Q32_H_


#include "config.h"
#include "SPI.h"


/******************* FLASHض ************************/
#define SFC_WREN        0x06        //Flash
#define SFC_WRDI        0x04
#define SFC_RDSR        0x05
#define SFC_WRSR        0x01
#define SFC_READ        0x03
#define SFC_FASTREAD    0x0B
#define SFC_RDID        0xAB
#define SFC_RDJID        0x9F

#define SFC_PAGEPROG    0x02
#define SFC_RDCR        0xA1
#define SFC_WRCR        0xF1
#define SFC_SECTORER1   0xD7        //PM25LV040 ָ
#define SFC_SECTORER2   0x20        //W25Xxx ָ
#define SFC_BLOCKER     0xD8
#define SFC_CHIPER      0xC7

sbit SPI_CE  = P4^0;     
sbit SPI_SO  = P4^2;     
sbit SPI_SI  = P4^1;     
sbit SPI_SCK = P4^3;  

/*---------------------------------------------------------
ɵùܺ
----------------------------------------------------------*/

u32     W25QXX_INIT(void);      //ʼW25QXX, ֵΪ MemorySize, δʶͺ, 򷵻 0

u32     W25QXX_Get_MemorySize(void);    // MemorySize

void    W25QXX_Read(u32 addr, u8 *buf, u32 Size);       //,޳

void    W25QXX_Write(u32 addr, u8 *buf, u32 Size);      //д,޳

void    W25QXX_WriteCache(void);    //Ϊ˼СڴʹСдЧ, дʹһӳд, жW25QXXĲɺ, Ӧһα, ʹд


void FlashCheckID(void);
void FlashWriteEnable(void);
void FlashSectorErase(u32 addr);
void SPI_DMA_Write_Nbytes(u32 addr, u16 size);
void SPI_DMA_Write_Sector(u32 addr,u8 *buf);
void SPI_DMA_Read2Buffer(u32 addr, u8 *buf, u16 size);
void SPI_DMA_Read_Nbytes(u32 addr, u16 size);

u8 CheckFlashBusy(void);
u32 getFlashSize(u8 isPrint);

#endif



